Cdio447/Areas/Admin/Controllers/HomeAdminController.cs
using System.Web.Mvc;
﻿using Cdio447.Code;
using Cdio447.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Cdio447.Areas.Admin.Models;
using System.Data.Entity;
using Cdio447.Models;

namespace Cdio447.Areas.Admin.Controllers
{
    public class HomeAdminController : CheckloginController
    {
        private DBContext db = null;
        public HomeAdminController()
        {
            db = new DBContext();
        }
        // GET: Admin/Home
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult getInfor() {
            homepage data = new homepage();
            var today = DateTime.Now;
            var gettotalamount = db.dou_histories
                                   .Sum(x => x.total_amount);
            var gettotaluser = db.users
                                 .Where(x => x.status == 1)
                                 .Count(x => x.id != 0);
            var gettran = db.withdrawl_histories
                            .Where(x => x.status == 2)
                            .Distinct().Count(u => u.id != 0);
            var gettrantoday = db.dou_histories
                                 .Where(x => DbFunctions.TruncateTime(x.created_at) >= DbFunctions.TruncateTime(today))
                                 .Count(u => u.id != 0);
            data.totalamount = gettotalamount / 10;
            data.totaluserOnline = gettotaluser;
            data.withdraw = gettran;
            data.totaltransactionToday = gettrantoday;
            ViewBag.Homepage = (data == null) ? null : data;
            return PartialView();
        }

        [HttpPost]
        public JsonResult GetRevenue()
        {
            List<DateTime> arrSevenday = new List<DateTime>();
            List<Revenue_View> arrData = new List<Revenue_View>();
            List<string> arrSevendayConvert = new List<string>();
            List<string> arrDataConvert = new List<string>();
            //get last seven day
            for (int i = 0; i <= 6; i++)
            {
                DateTime nDaysAgo;
                if (i == 0)
                {
                    nDaysAgo = DateTime.Today.AddDays(i);
                }
                else
                {
                    nDaysAgo = DateTime.Today.AddDays(-i);
                }
                arrSevenday.Add(nDaysAgo);
            }
            //get data last seven day
            for (int i = 0; i <= 6; i++)
            {
                var convertDate = arrSevenday[i];
                var getData = db.dou_histories.
                Where(x => DbFunctions.TruncateTime(x.created_at) == DbFunctions.TruncateTime(convertDate)).
                GroupBy(x => x.created_at).
                Select(x => new Revenue_View { totalAmount = x.Sum(a => a.total_amount) / 10 }).
                OrderBy(x => x.totalAmount).FirstOrDefault();
                if (getData == null)
                {
                    Revenue_View newIf = new Revenue_View();
                    newIf.totalAmount = 0;
                    arrData.Add(newIf);
                }
                else
                {
                    arrData.Add(getData);
                }
            }
            foreach (var get in arrSevenday)
            {
                arrSevendayConvert.Add(get.ToShortDateString());
            }
            foreach (var get in arrData)
            {
                arrDataConvert.Add(get.totalAmount.ToString());
            }
            var merge = arrSevendayConvert.Concat(arrDataConvert);
            return Json(merge);
        }
    }
}

Cdio447/Areas/Admin/Views/HomeAdmin/Index.cshtml
@{
    ViewBag.Title = "Home";
    Layout = "~/Areas/Admin/Views/Shared/_Layout.cshtml";
}
@section styles {
    <link href="~/Content/assets/css/chart.min.css" rel="stylesheet" type="text/css" />
}
<div class="row">
    <div class="col-12 col-lg-12">
        @{ Html.RenderAction("getInfor", "HomeAdmin"); }
    </div>
    <div class="col-12 col-lg-9">
        <div class="user-infopl-statis my-3">
            <div class="box-canvasUserSta">
                <canvas id="canvasUserSta"></canvas>
            </div>
        </div>
    </div>
</div>
@section scripts {
    <script src="~/Content/assets/js/chart.min.js"></script>
    <script>
        //ajax get data last seven date
        function userStatistic(handleData) {
            $.ajax({
                url: "/HomeAdmin/GetRevenue",
                type: 'POST',
                data: JSON.stringify([]),
                contentType: 'application/json;charset=UTF-8',
                dataType: "json",
                async: true,
                success: function (response) {
                    handleData(response);
                },
                error: function () {
                    alert("Có lỗi xảy ra trong quá trình thống kê");
                }
            });
            return false;
        }
        var arrSevenData = [];
        //call ajax to drwal chart
        userStatistic(function (data) {
            $.each(data, function (i, item) {
                arrSevenData.push(item);
            });
            let myChart = document.getElementById('canvasUserSta').getContext('2d');
            // Global Options
            Chart.defaults.global.defaultFontSize = 18;
            Chart.defaults.global.defaultFontColor = '#777';
            let massPopChart = new Chart(myChart, {
                type: 'bar', // bar, horizontalBar, pie, line, doughnut, radar, polarArea
                data: {
                    labels: [
                        arrSevenData[6],
                        arrSevenData[5],
                        arrSevenData[4],
                        arrSevenData[3],
                        arrSevenData[2],
                        arrSevenData[1],
                        arrSevenData[0],
                    ],
                    datasets: [{
                        label: 'VND',
                        data: [
                            arrSevenData[13],
                            arrSevenData[12],
                            arrSevenData[11],
                            arrSevenData[10],
                            arrSevenData[9],
                            arrSevenData[8],
                            arrSevenData[7],
                        ],
                        //backgroundColor:'green',
                        backgroundColor: [
                            'rgba(255, 99, 132, 0.6)',
                            'rgba(54, 162, 235, 0.6)',
                            'rgba(255, 206, 86, 0.6)',
                            'rgba(75, 192, 192, 0.6)',
                            'rgba(153, 102, 255, 0.6)',
                            'rgba(255, 159, 64, 0.6)',
                            'rgba(255, 99, 132, 0.6)'
                        ],
                        borderWidth: 1,
                        borderColor: '#777',
                        hoverBorderWidth: 3,
                        hoverBorderColor: '#000'
                    }]
                },
                options: {
                    title: {
                        display: true,
                        text: 'Thống kê doanh thu 7 ngày gần đây',
                        fontSize: 25
                    },
                    legend: {
                        display: false,
                    },
                    layout: {
                        padding: {
                            left: 50,
                            right: 0,
                            bottom: 0,
                            top: 0
                        }
                    },
                    tooltips: {
                        enabled: true
                    }
                }
            });
        });
    </script>
}

Cdio447/Areas/Admin/Views/HomeAdmin/getInfor.cshtml
@using Cdio447.Supports
@{
    Layout = null;
    var getinfo = (Cdio447.Areas.Admin.Models.homepage)ViewBag.Homepage;
}
<div class="d-flex">
    <div class="box-item-admin">
        <p>Số người dùng đang Online</p>
        <p>
            @if(getinfo != null)
            {
                <span>@getinfo.totaluserOnline</span>
            }
            else
            {
                <span>0</span>
            }
        </p>
    </div>
    <div class="box-item-admin">
        <p>Tổng doanh thu</p>
        <p>
            @if (getinfo != null)
            {
                <span>@FunctionSupport.convertVND(getinfo.totalamount, " - VND") </span>
            }
            else
            {
                <span>0 - VND</span>
            }
        </p>
    </div>
    <div class="box-item-admin">
        <p>Số yêu cầu rút tiền</p>
        <p>
            @if (getinfo != null)
            {
                <span>@getinfo.withdraw</span>
            }
            else
            {
                <span>0</span>
            }
        </p>
    </div>
    <div class="box-item-admin">
        <p>Số giao dịch hôm nay</p>
        <p>
            @if (getinfo != null)
            {
                <span>@getinfo.totaltransactionToday</span>
            }
            else
            {
                <span>0</span>
            }
        </p>
    </div>
</div>